| Apache Ignite C++

Public Member Functions | Friends | List of all members
ignite::binary::BinaryRawWriter Class Reference

Binary raw writer. More...

`#include <binary_raw_writer.h>`

## Public Member Functions
| BinaryRawWriter (ignite::impl::binary::BinaryWriterImpl *impl)
| Constructor. More...
void | WriteInt8 (int8_t val)
| Write 8-byte signed integer. More...
void | WriteInt8Array (const int8_t *val, int32_t len)
| Write array of 8-byte signed integers. More...
void | WriteBool (bool val)
| Write bool. More...
void | WriteBoolArray (const bool *val, int32_t len)
| Write array of bools. More...
void | WriteInt16 (int16_t val)
| Write 16-byte signed integer. More...
void | WriteInt16Array (const int16_t *val, int32_t len)
| Write array of 16-byte signed integers. More...
void | WriteUInt16 (uint16_t val)
| Write 16-byte unsigned integer. More...
void | WriteUInt16Array (const uint16_t *val, int32_t len)
| Write array of 16-byte unsigned integers. More...
void | WriteInt32 (int32_t val)
| Write 32-byte signed integer. More...
void | WriteInt32Array (const int32_t *val, int32_t len)
| Write array of 32-byte signed integers. More...
void | WriteInt64 (int64_t val)
| Write 64-byte signed integer. More...
void | WriteInt64Array (const int64_t *val, int32_t len)
| Write array of 64-byte signed integers. More...
void | WriteFloat (float val)
| Write float. More...
void | WriteFloatArray (const float *val, int32_t len)
| Write array of floats. More...
void | WriteDouble (double val)
| Write double. More...
void | WriteDoubleArray (const double *val, int32_t len)
| Write array of doubles. More...
void | WriteGuid (const Guid &val)
| Write Guid. More...
void | WriteGuidArray (const Guid *val, int32_t len)
| Write array of Guids. More...
void | WriteDate (const Date &val)
| Write Date. More...
void | WriteDateArray (const Date *val, int32_t len)
| Write array of Dates. More...
void | WriteTimestamp (const Timestamp &val)
| Write Timestamp. More...
void | WriteTimestampArray (const Timestamp *val, int32_t len)
| Write array of Timestamps. More...
void | WriteTime (const Time &val)
| Write Time. More...
void | WriteTimeArray (const Time *val, int32_t len)
| Write array of Time. More...
void | WriteString (const char *val)
| Write string. More...
void | WriteString (const char *val, int32_t len)
| Write string. More...
void | WriteString (const std::string &val)
| Write string. More...
BinaryStringArrayWriter | WriteStringArray ()
| Start string array write. More...
void | WriteBinaryEnum (BinaryEnumEntry entry)
| Write enum entry. More...
void | WriteNull ()
| Write NULL value.
template<typename T >
BinaryArrayWriter< T > | WriteArray ()
| Start array write. More...
template<typename T >
BinaryCollectionWriter< T > | WriteCollection ()
| Start collection write. More...
template<typename T >
BinaryCollectionWriter< T > | WriteCollection (CollectionType::Type typ)
| Start collection write. More...
template<typename InputIterator >
void | WriteCollection (InputIterator first, InputIterator last)
| Write values in interval [first, last). More...
template<typename InputIterator >
void | WriteCollection (InputIterator first, InputIterator last, CollectionType::Type typ)
| Write values in interval [first, last). More...
template<typename K , typename V >
BinaryMapWriter< K, V > | WriteMap ()
| Start map write. More...
template<typename K , typename V >
BinaryMapWriter< K, V > | WriteMap (MapType::Type typ)
| Start map write. More...
template<typename T >
void | WriteObject (const T &val)
| Write object. More...
template<typename T >
void | WriteEnum (T val)
| Write binary enum entry. More...

## Friends
class | ignite::impl::binary::BinaryUtils

## Detailed Description

Binary raw writer.

This class is implemented as a reference to an implementation so copying of this class instance will only create another reference to the same underlying object.

Note
  User should not store copy of this instance as it can be invalidated as soon as the initially passed to user instance has been destructed. For example this means that if user received an instance of this class as a function argument then he should not store and use copy of this class out of the scope of this function.

## Constructor & Destructor Documentation

## ◆ BinaryRawWriter()

ignite::binary::BinaryRawWriter::BinaryRawWriter | ( | ignite::impl::binary::BinaryWriterImpl * | impl | ) |

Constructor.

Internal method. Should not be used by user.

Parameters

  impl | Implementation.

## Member Function Documentation

## ◆ WriteArray()

template<typename T >

BinaryArrayWriter<T> ignite::binary::BinaryRawWriter::WriteArray | ( |  | ) |
| inline

Start array write.

Every time you get a BinaryArrayWriter from BinaryRawWriter you start writing session. Only one single writing session can be open at a time. So it is not allowed to start new writing session without calling BinaryArrayWriter::Close() method prior on obtained BinaryArrayWriter class instance.

Returns
  Array writer.

## ◆ WriteBinaryEnum()

void ignite::binary::BinaryRawWriter::WriteBinaryEnum | ( | BinaryEnumEntry | entry | ) |

Write enum entry.

Parameters

  entry | Binary enum entry.

## ◆ WriteBool()

void ignite::binary::BinaryRawWriter::WriteBool | ( | bool | val | ) |

Write bool.

Maps to "short" type in Java.

Parameters

  val | Value.

## ◆ WriteBoolArray()

void ignite::binary::BinaryRawWriter::WriteBoolArray | ( | const bool * | val,
|  | int32_t | len
| ) |  |

Write array of bools.

Maps to "bool[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteCollection() [1/4]

template<typename T >

BinaryCollectionWriter<T> ignite::binary::BinaryRawWriter::WriteCollection | ( |  | ) |
| inline

Start collection write.

Every time you get a BinaryCollectionWriter from BinaryRawWriter you start writing session. Only one single writing session can be open at a time. So it is not allowed to start new writing session without calling BinaryCollectionWriter::Close() method prior on obtained BinaryCollectionWriter class instance.

Returns
  Collection writer.

## ◆ WriteCollection() [2/4]

template<typename T >

BinaryCollectionWriter<T> ignite::binary::BinaryRawWriter::WriteCollection | ( | CollectionType::Type | typ | ) |
| inline

Start collection write.

Every time you get a BinaryCollectionWriter from BinaryRawWriter you start writing session. Only one single writing session can be open at a time. So it is not allowed to start new writing session without calling BinaryCollectionWriter::Close() method prior on obtained BinaryCollectionWriter class instance.

Parameters

  typ | Collection type.

Returns
  Collection writer.

## ◆ WriteCollection() [3/4]

template<typename InputIterator >

void ignite::binary::BinaryRawWriter::WriteCollection | ( | InputIterator | first,
|  | InputIterator | last
| ) |  |
| inline

Write values in interval [first, last).

Parameters

  first | Iterator pointing to the beginning of the interval.
  last | Iterator pointing to the end of the interval.

## ◆ WriteCollection() [4/4]

template<typename InputIterator >

void ignite::binary::BinaryRawWriter::WriteCollection | ( | InputIterator | first,
|  | InputIterator | last,
|  | CollectionType::Type | typ
| ) |  |
| inline

Write values in interval [first, last).

Parameters

  first | Iterator pointing to the beginning of the interval.
  last | Iterator pointing to the end of the interval.
  typ | Collection type.

## ◆ WriteDate()

void ignite::binary::BinaryRawWriter::WriteDate | ( | const Date & | val | ) |

Write Date.

Maps to "Date" type in Java.

Parameters

  val | Value.

## ◆ WriteDateArray()

void ignite::binary::BinaryRawWriter::WriteDateArray | ( | const Date * | val,
|  | int32_t | len
| ) |  |

Write array of Dates.

Maps to "Date[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteDouble()

void ignite::binary::BinaryRawWriter::WriteDouble | ( | double | val | ) |

Write double.

Maps to "double" type in Java.

Parameters

  val | Value.

## ◆ WriteDoubleArray()

void ignite::binary::BinaryRawWriter::WriteDoubleArray | ( | const double * | val,
|  | int32_t | len
| ) |  |

Write array of doubles.

Maps to "double[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteEnum()

template<typename T >

void ignite::binary::BinaryRawWriter::WriteEnum | ( | T | val | ) |
| inline

Write binary enum entry.

Parameters

  val | Binary enum entry.

@trapam T Enum type. BinaryEnum class template should be specialized for the type.

## ◆ WriteFloat()

void ignite::binary::BinaryRawWriter::WriteFloat | ( | float | val | ) |

Write float.

Maps to "float" type in Java.

Parameters

  val | Value.

## ◆ WriteFloatArray()

void ignite::binary::BinaryRawWriter::WriteFloatArray | ( | const float * | val,
|  | int32_t | len
| ) |  |

Write array of floats.

Maps to "float[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteGuid()

void ignite::binary::BinaryRawWriter::WriteGuid | ( | const Guid & | val | ) |

Write Guid.

Maps to "UUID" type in Java.

Parameters

  val | Value.

## ◆ WriteGuidArray()

void ignite::binary::BinaryRawWriter::WriteGuidArray | ( | const Guid * | val,
|  | int32_t | len
| ) |  |

Write array of Guids.

Maps to "UUID[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteInt16()

void ignite::binary::BinaryRawWriter::WriteInt16 | ( | int16_t | val | ) |

Write 16-byte signed integer.

Maps to "short" type in Java.

Parameters

  val | Value.

## ◆ WriteInt16Array()

void ignite::binary::BinaryRawWriter::WriteInt16Array | ( | const int16_t * | val,
|  | int32_t | len
| ) |  |

Write array of 16-byte signed integers.

Maps to "short[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteInt32()

void ignite::binary::BinaryRawWriter::WriteInt32 | ( | int32_t | val | ) |

Write 32-byte signed integer.

Maps to "int" type in Java.

Parameters

  val | Value.

## ◆ WriteInt32Array()

void ignite::binary::BinaryRawWriter::WriteInt32Array | ( | const int32_t * | val,
|  | int32_t | len
| ) |  |

Write array of 32-byte signed integers.

Maps to "int[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteInt64()

void ignite::binary::BinaryRawWriter::WriteInt64 | ( | int64_t | val | ) |

Write 64-byte signed integer.

Maps to "long" type in Java.

Parameters

  val | Value.

## ◆ WriteInt64Array()

void ignite::binary::BinaryRawWriter::WriteInt64Array | ( | const int64_t * | val,
|  | int32_t | len
| ) |  |

Write array of 64-byte signed integers.

Maps to "long[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteInt8()

void ignite::binary::BinaryRawWriter::WriteInt8 | ( | int8_t | val | ) |

Write 8-byte signed integer.

Maps to "byte" type in Java.

Parameters

  val | Value.

## ◆ WriteInt8Array()

void ignite::binary::BinaryRawWriter::WriteInt8Array | ( | const int8_t * | val,
|  | int32_t | len
| ) |  |

Write array of 8-byte signed integers.

Maps to "byte[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteMap() [1/2]

template<typename K , typename V >

BinaryMapWriter<K, V> ignite::binary::BinaryRawWriter::WriteMap | ( |  | ) |
| inline

Start map write.

Every time you get a BinaryMapWriter from BinaryRawWriter you start writing session. Only one single writing session can be open at a time. So it is not allowed to start new writing session without calling BinaryMapWriter::Close() method prior on obtained BinaryMapWriter class instance.

Returns
  Map writer.

## ◆ WriteMap() [2/2]

template<typename K , typename V >

BinaryMapWriter<K, V> ignite::binary::BinaryRawWriter::WriteMap | ( | MapType::Type | typ | ) |
| inline

Start map write.

Every time you get a BinaryMapWriter from BinaryRawWriter you start writing session. Only one single writing session can be open at a time. So it is not allowed to start new writing session without calling BinaryMapWriter::Close() method prior on obtained BinaryMapWriter class instance.

Parameters

  typ | Map type.

Returns
  Map writer.

## ◆ WriteObject()

template<typename T >

void ignite::binary::BinaryRawWriter::WriteObject | ( | const T & | val | ) |
| inline

Write object.

Parameters

  val | Object.

## ◆ WriteString() [1/3]

void ignite::binary::BinaryRawWriter::WriteString | ( | const char * | val | ) |

Write string.

Parameters

  val | Null-terminated character array.

## ◆ WriteString() [2/3]

void ignite::binary::BinaryRawWriter::WriteString | ( | const char * | val,
|  | int32_t | len
| ) |  |

Write string.

Parameters

  val | String.
  len | String length (characters).

## ◆ WriteString() [3/3]

void ignite::binary::BinaryRawWriter::WriteString | ( | const std::string & | val | ) |
| inline

Write string.

Parameters

  val | String.

## ◆ WriteStringArray()

BinaryStringArrayWriter ignite::binary::BinaryRawWriter::WriteStringArray | ( |  | ) |

Start string array write.

Every time you get a BinaryStringArrayWriter from BinaryRawWriter you start writing session. Only one single writing session can be open at a time. So it is not allowed to start new writing session without calling BinaryStringArrayWriter::Close() method prior on obtained BinaryStringArrayWriter class instance.

Returns
  String array writer.

## ◆ WriteTime()

void ignite::binary::BinaryRawWriter::WriteTime | ( | const Time & | val | ) |

Write Time.

Maps to "Time" type in Java.

Parameters

  val | Value.

## ◆ WriteTimeArray()

void ignite::binary::BinaryRawWriter::WriteTimeArray | ( | const Time * | val,
|  | int32_t | len
| ) |  |

Write array of Time.

Maps to "Time[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteTimestamp()

void ignite::binary::BinaryRawWriter::WriteTimestamp | ( | const Timestamp & | val | ) |

Write Timestamp.

Maps to "Timestamp" type in Java.

Parameters

  val | Value.

## ◆ WriteTimestampArray()

void ignite::binary::BinaryRawWriter::WriteTimestampArray | ( | const Timestamp * | val,
|  | int32_t | len
| ) |  |

Write array of Timestamps.

Maps to "Timestamp[]" type in Java.

Parameters

  val | Array.
  len | Array length.

## ◆ WriteUInt16()

void ignite::binary::BinaryRawWriter::WriteUInt16 | ( | uint16_t | val | ) |

Write 16-byte unsigned integer.

Maps to "char" type in Java.

Parameters

  val | Value.

## ◆ WriteUInt16Array()

void ignite::binary::BinaryRawWriter::WriteUInt16Array | ( | const uint16_t * | val,
|  | int32_t | len
| ) |  |

Write array of 16-byte unsigned integers.

Maps to "char[]" type in Java.

Parameters

  val | Array.
  len | Array length.

The documentation for this class was generated from the following files:

- binary_raw_writer.h
- binary_raw_writer.cpp